searchNodes=[{"doc":"Onnx runtime intepreter for Elixir. Deep Learning inference framework. Basic Usage You get the trained onnx model and save it in a directory that your application can read. &quot;your-app/priv&quot; may be good choice. $ cp your-trained-model.onnx ./priv Next, you will create a module that interfaces with the deep learning model. The module will need pre-processing and post-processing in addition to inference processing, as in the example following. OnnxInterp provides inference processing only. You put use OnnxInterp at the beginning of your module, specify the model path as an optional argument. In the inference section, you will put data input to the model ( OnnxInterp.set_input_tensor/3 ), inference execution ( OnnxInterp.invoke/1 ), and inference result retrieval ( OnnxInterp.get_output_tensor/2 ). defmodule YourApp.YourModel do use OnnxInterp, model: &quot;priv/your-trained-model.onnx&quot; def predict(data) do # preprocess # to convert the data to be inferred to the input format of the model. input_bin = convert-float32-binaries(data) # inference # typical I/O data for Onnx models is a serialized 32-bit float tensor. output_bin = __MODULE__ |&gt; OnnxInterp.set_input_tensor(0, input_bin) |&gt; OnnxInterp.invoke() |&gt; OnnxInterp.get_output_tensor(0) # postprocess # add your post-processing here. # you may need to reshape output_bin to tensor at first. tensor = output_bin |&gt; Nx.from_binary({:f, 32}) |&gt; Nx.reshape({size-x, size-y, :auto}) * your-postprocessing * ... end end","ref":"OnnxInterp.html","title":"OnnxInterp","type":"module"},{"doc":"Get the flat binary from the output tensor on the interpreter. Parameters mod - modules' names or session. index - index of output tensor in the model","ref":"OnnxInterp.html#get_output_tensor/2","title":"OnnxInterp.get_output_tensor/2","type":"function"},{"doc":"Get the propaty of the onnx model. Parameters mod - modules' names","ref":"OnnxInterp.html#info/1","title":"OnnxInterp.info/1","type":"function"},{"doc":"Invoke prediction. Parameters mod - modules' names","ref":"OnnxInterp.html#invoke/1","title":"OnnxInterp.invoke/1","type":"function"},{"doc":"Execute post processing: nms. Parameters mod - modules' names num_boxes - number of candidate boxes num_class - number of category class boxes - binaries, serialized boxes tensor[ num_boxes ][4]; dtype: float32 scores - binaries, serialized score tensor[ num_boxes ][ num_class ]; dtype: float32 opts iou_threshold: - IOU threshold score_threshold: - score cutoff threshold sigma: - soft IOU parameter boxrepr: - type of box representation 0 - center pos and width/height 1 - top-left pos and width/height 2 - top-left and bottom-right corner pos","ref":"OnnxInterp.html#non_max_suppression_multi_class/5","title":"OnnxInterp.non_max_suppression_multi_class/5","type":"function"},{"doc":"Execute the inference session. In session mode, data input/execution of inference/output of results to the DL model is done all at once. Parameters session - session. Examples. output_bin = session ( ) |&gt; OnnxInterp . set_input_tensor ( 0 , input_bin ) |&gt; OnnxInterp . run ( ) |&gt; OnnxInterp . get_output_tensor ( 0 )","ref":"OnnxInterp.html#run/1","title":"OnnxInterp.run/1","type":"function"},{"doc":"Put a flat binary to the input tensor on the interpreter. Parameters mod - modules' names or session. index - index of input tensor in the model bin - input data - flat binary, cf. serialized tensor opts - data conversion","ref":"OnnxInterp.html#set_input_tensor/4","title":"OnnxInterp.set_input_tensor/4","type":"function"},{"doc":"Stop the onnx-runtime interpreter. Parameters mod - modules' names","ref":"OnnxInterp.html#stop/1","title":"OnnxInterp.stop/1","type":"function"},{"doc":"Onnx runtime interpreter for Elixir. It is a Deep Learning inference framework that can be used in the same way as my TflInterp.","ref":"readme.html","title":"OnnxInterp","type":"extras"},{"doc":"I have confirmed it works in the following OS environment. Windows 10 with Visual C++ 2019 WSL2/Ubuntu 20.04 Linux Mint 20 &quot;Ulyana&quot;","ref":"readme.html#platform","title":"OnnxInterp - Platform","type":"extras"},{"doc":"cmake 3.13 or later is required. Visual C++ 2019 for Windows.","ref":"readme.html#requirements","title":"OnnxInterp - Requirements","type":"extras"},{"doc":"You can install it by adding onnx_interp to the mix.exs dependency list as follows: def deps do [ { :onnx_interp , &quot;~&gt; 0.1.2&quot; } ] end","ref":"readme.html#installation","title":"OnnxInterp - Installation","type":"extras"},{"doc":"You get the trained Onnx model and save it in a directory that your application can read. &quot;your-app/priv&quot; may be good choice. $ cp your-trained-model.onnx ./priv Next, you will create a module that interfaces with the deep learning model. The module will need pre-processing and post-processing in addition to inference processing, as in the example following. OnnxInterp provides inference processing only. You put use OnnxInterp at the beginning of your module, specify the model path as an optional argument. In the inference section, you will put data input to the model ( OnnxInterp.set_input_tensor/3 ), inference execution ( OnnxInterp.invoke/1 ), and inference result retrieval ( OnnxInterp.get_output_tensor/2 ). defmodule YourApp.YourModel do use OnnxInterp, model: &quot;priv/your-trained-model.onnx&quot; def predict(data) do # preprocess # to convert the data to be inferred to the input format of the model. input_bin = convert-float32-binaries(data) # inference # typical I/O data for Onnx models is a serialized 32-bit float tensor. output_bin = __MODULE__ |&gt; OnnxInterp.set_input_tensor(0, input_bin) |&gt; OnnxInterp.invoke() |&gt; OnnxInterp.get_output_tensor(0) # postprocess # add your post-processing here. # you may need to reshape output_bin to tensor at first. tensor = output_bin |&gt; Nx.from_binary({:f, 32}) |&gt; Nx.reshape({size-x, size-y, :auto}) * your-postprocessing * ... end end","ref":"readme.html#basic-usage","title":"OnnxInterp - Basic Usage","type":"extras"},{"doc":"There is Fast Neural Style Transfer: Candy demo in the demo directory. This demo artistically converts a photo of a frog 'flog.jpg' in the demo directory and saves it as 'candy_flog.jpg'. First, you download the trained DNN model &quot;candy-9.onnx&quot; from the following URL and place it in the demo directory. candy-9.onnx: https://github.com/onnx/models/raw/main/vision/style_transfer/fast_neural_style/model/candy-9.onnx You can run the demo by following these steps. $ cd demo $ mix deps.get $ mix run -e &quot;CandyDemo.demo&quot; Let's enjoy ;-)","ref":"readme.html#demo","title":"OnnxInterp - Demo","type":"extras"},{"doc":"OnnxInterp is licensed under the Apache License Version 2.0.","ref":"readme.html#license","title":"OnnxInterp - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Breaking Changes the previous download source of nlohmann-json is gone, so changed to another one.","ref":"changelog.html#release-0-1-5-aug-2-2022","title":"Changelog - Release 0.1.5(Aug 2 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes added two more ways to specify box in NMS. include NanoDet plus object detection demo. rename the folder of Candy demo.","ref":"changelog.html#release-0-1-4-aug-2-2022","title":"Changelog - Release 0.1.4(Aug 2 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes fixed command message of non_max_suppression_multi_class/7. include livebook demo: Semantic Segmentation for Self Driving Cars by UNet. include YOLOv7 object detection demo.","ref":"changelog.html#release-0-1-3-jul-09-2022","title":"Changelog - Release 0.1.3(Jul 09 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes confirmed it works in Linux Mint 20.","ref":"changelog.html#release-0-1-2-may-20-2022","title":"Changelog - Release 0.1.2(May 20 2022)","type":"extras"},{"doc":"Experimental version","ref":"changelog.html#release-0-1-1-may-18-2022","title":"Changelog - Release 0.1.1(May 18 2022)","type":"extras"}]